﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Sirenix.OdinInspector;

namespace KairoEngine.Core.ConfigOptions
{
    public class ConfigOptionBase : ScriptableObject, IConfigOption
    {
            [PropertyOrder(0), HorizontalGroup("id")] public string title;
            [PropertyOrder(1), HorizontalGroup("id", 0.3f), HideLabel] public string id;
            [PropertyOrder(3)] public ConfigOptionUIType uiElementType;

            public virtual ConfigOptionUiData GetUiData()
            {
                throw new System.NotImplementedException();
            }

            public virtual void LoadValue(bool debug)
            {
                throw new System.NotImplementedException();
            }

            public virtual void SetDefaultValue()
            {
                throw new System.NotImplementedException();
            }

            public virtual void SetValue(ConfigOptionData data, bool save = false)
            {
                throw new System.NotImplementedException();
            }

    }

}
