﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace KairoEngine.Core
{
    public enum StoryStepType
    {
        Line,
        Branch,
        Path
    }

    [System.Serializable]
    public class StoryStepData
    {
        public StoryStepType category;
        public string text;
        public List<string> tags;
        public List<string> branches;
        public int path = 0;

        public StoryStepData(StoryStepType category, string text, List<string> tags, List<string> branches, int path = 0)
        {
            this.category = category;
            this.text = text;
            this.tags = tags;
            this.branches = branches;
            this.path = path;
        }
    }
}

